<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <style>
        body {
            font-family: sans-serif;
        }

        ul {
            list-style: none;
        }

        li {
            display: inline;
            padding-right: 1rem;
        }

        h1 {
            background-color: navy;
            color: white;
        }
    </style>
</head>

<body>
    <h1>Preparation</h1>
    <p>
        First install a simple HTTP file-server, such as
    </p>
    <pre>
        npm install http-server -g
    </pre>
    <p>
        Then launch it in the same directory where you have your files.
    </p>
    <pre>
        http-server
    </pre>

    <br/>
    <h1>Word Freqs</h1>
    <ul>
        <script>
            function fetch(url) {
                let http = new XMLHttpRequest();
                http.open('GET', url, false);
                http.send();
                return http.responseText;
            }

            function mostFrequent(data, maxWords = 10, minSize = 4) {
                let freqs = data
                    .split(/[^a-z’]+/i)
                    .filter(w => w.length >= minSize)
                    .map(w => w.toLowerCase())
                    .reduce((f, w) => {
                        f.set(w, 1 + (f.get(w) || 0));
                        return f;
                    }, new Map())
                    ;
                return [...freqs.entries()]
                    .sort((l, r) => r[1] - l[1])
                    .slice(0, maxWords)
                    ;
            }

            function uniform(min, max) {
                return Math.floor(Math.random() * (max - min + 1)) + min;
            }

            function hex(n) {
                return n.toString(16);
            }

            function color() {
                return '#' + hex(uniform(0, 256)) + hex(uniform(0, 256)) + hex(uniform(0, 256));
            }

            let text = fetch('The-Three-Musketeers.txt');
            let result = mostFrequent(text, 250);
            let maxFreq = result[0][1];
            let minFreq = result[result.length - 1][1];
            let maxFont = 200;
            let minFont = 20;
            let scale = (maxFont - minFont) / (maxFreq - minFreq);

            result
                .sort((left, right) => 0.5 - Math.random())
                .forEach(p => {
                    let word = p[0];
                    let freq = p[1];
                    let html = `<li><span style="font-size: ${freq * scale}px; color:${color()}">${word}</span> (${freq})</li>`;
                    document.write(html);
                });
        </script>
    </ul>
</body>

</html>